Enumerations

Constant value enumerations. More...

## Enumerations

enum | cp_status_t { CP_OK = 0 , CP_ERR_RESOURCE , CP_ERR_UNKNOWN , CP_ERR_IO , CP_ERR_MALFORMED , CP_ERR_CONFLICT , CP_ERR_DEPENDENCY , CP_ERR_RUNTIME }
| An enumeration of status codes returned by API functions. More...
enum | cp_plugin_state_t { CP_PLUGIN_UNINSTALLED , CP_PLUGIN_INSTALLED , CP_PLUGIN_RESOLVED , CP_PLUGIN_STARTING , CP_PLUGIN_STOPPING , CP_PLUGIN_ACTIVE }
| An enumeration of possible plug-in states. More...
enum | cp_log_severity_t { CP_LOG_DEBUG , CP_LOG_INFO , CP_LOG_WARNING , CP_LOG_ERROR }
| An enumeration of possible message severities for framework logging. More...

## Detailed Description

Constant value enumerations.

## Enumeration Type Documentation

## cp_status_t

enum cp_status_t

An enumeration of status codes returned by API functions.

Most of the interface functions return a status code. The returned status code either indicates successful completion of the operation or some specific kind of error. Some functions do not return a status code because they never fail.

Enumerator
CP_OK | Operation was performed successfully (equals to zero).
CP_ERR_RESOURCE | Not enough memory or other operating system resources available.
CP_ERR_UNKNOWN | The specified object is unknown to the framework.
CP_ERR_IO | An I/O error occurred.
CP_ERR_MALFORMED | Malformed plug-in descriptor was encountered when loading a plug-in.
CP_ERR_CONFLICT | Plug-in or symbol conflicts with another plug-in or symbol.
CP_ERR_DEPENDENCY | Plug-in dependencies could not be satisfied.
CP_ERR_RUNTIME | Plug-in runtime signaled an error.

## cp_plugin_state_t

enum cp_plugin_state_t

An enumeration of possible plug-in states.

Plug-in states are controlled by plug-in management functions. Plug-in states can be observed by registering a plug-in listener function or by calling cp_get_plugin_state.

See also
  cp_plugin_listener_t
  cp_get_plugin_state

Enumerator
CP_PLUGIN_UNINSTALLED | Plug-in is not installed. No plug-in information has been loaded.
CP_PLUGIN_INSTALLED | Plug-in is installed. At this stage the plug-in information has been loaded but its dependencies to other plug-ins has not yet been resolved. The plug-in runtime has not been loaded yet. The extension points and extensions provided by the plug-in have been registered.

CP_PLUGIN_RESOLVED

Plug-in dependencies have been resolved.

At this stage it has been verified that the dependencies of the plug-in are satisfied and the plug-in runtime has been loaded but it is not active (it has not been started or it has been stopped). Plug-in is resolved when a dependent plug-in is being resolved or before the plug-in is started. Plug-in is put back to installed stage if its dependencies are being uninstalled.

CP_PLUGIN_STARTING

Plug-in is starting.

The plug-in has been resolved and the start function (if any) of the plug-in runtime is about to be called. A plug-in is started when explicitly requested by the main program or when a dependent plug-in is about to be started or when a dynamic symbol defined by the plug-in is being resolved. This state is omitted and the state changes directly from resolved to active if the plug-in runtime does not define a start function.

CP_PLUGIN_STOPPING

Plug-in is stopping.

The stop function (if any) of the plug-in runtime is about to be called. A plug-in is stopped if the start function fails or when stopping is explicitly requested by the main program or when its dependencies are being stopped. This state is omitted and the state changes directly from active to resolved if the plug-in runtime does not define a stop function.

CP_PLUGIN_ACTIVE | Plug-in has been successfully started and it has not yet been stopped.

## cp_log_severity_t

enum cp_log_severity_t

An enumeration of possible message severities for framework logging.

These constants are used when passing a log message to a logger function and when registering a logger function.

Enumerator
CP_LOG_DEBUG | Used for detailed debug messages.
CP_LOG_INFO | Used for informational messages such as plug-in state changes.
CP_LOG_WARNING | Used for messages warning about possible problems.
CP_LOG_ERROR | Used for messages reporting errors.

Generated on for C-Pluff C API by 1.15.0